'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

exports.route = route;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _koaRouter = require('koa-router');

var _koaRouter2 = _interopRequireDefault(_koaRouter);

var HttpMethod = (function () {
  function HttpMethod() {
    _classCallCheck(this, HttpMethod);
  }

  // decorator factory
  //export function route(path:string, method:string, ...middleware:Array<Function>) {
  _createClass(HttpMethod, null, [{
    key: 'HEAD',
    value: 'HEAD',
    enumerable: true
  }, {
    key: 'OPTIONS',
    value: 'OPTIONS',
    enumerable: true
  }, {
    key: 'GET',
    value: 'GET',
    enumerable: true
  }, {
    key: 'PUT',
    value: 'PUT',
    enumerable: true
  }, {
    key: 'PATCH',
    value: 'PATCH',
    enumerable: true
  }, {
    key: 'POST',
    value: 'POST',
    enumerable: true
  }, {
    key: 'DELETE',
    value: 'DELETE',
    enumerable: true
  }]);

  return HttpMethod;
})();

exports.HttpMethod = HttpMethod;

function route(path, method) {
  for (var _len = arguments.length, middleware = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
    middleware[_key - 2] = arguments[_key];
  }

  if (typeof path !== 'string') throw new TypeError('Value of argument \'path\' violates contract, expected string got ' + (path === null ? 'null' : path instanceof Object && path.constructor ? path.constructor.name : typeof path));
  if (typeof method !== 'string') throw new TypeError('Value of argument \'method\' violates contract, expected string got ' + (method === null ? 'null' : method instanceof Object && method.constructor ? method.constructor.name : typeof method));

  return function (target, key, descriptor) {
    var _target$prototype$router2, _target$prototype$router3, _target$prototype$router4, _target$prototype$router5, _target$prototype$router6, _target$prototype$router7, _target$prototype$router8;

    if (!path) {
      throw TypeError('@route should have at least "path" argument');
    }

    if (!target.prototype.router) {
      target.prototype.router = new _koaRouter2['default']();
    }

    // on class
    if (target && !key && !descriptor) {
      if (method) throw TypeError('@route on class should not have "method"');
      target.prototype.router.prefix(path);
      if (middleware.length > 0) {
        var _target$prototype$router;

        (_target$prototype$router = target.prototype.router).use.apply(_target$prototype$router, middleware);
      }
      return;
    }

    //on methods
    if (!method) {
      throw TypeError('@route on method should have "method" as second argument');
    }

    switch (method) {
      case HttpMethod.HEAD:
        (_target$prototype$router2 = target.prototype.router).head.apply(_target$prototype$router2, [path].concat(middleware, [descriptor.value]));
        break;
      case HttpMethod.OPTIONS:
        (_target$prototype$router3 = target.prototype.router).options.apply(_target$prototype$router3, [path].concat(middleware, [descriptor.value]));
        break;
      case HttpMethod.GET:
        (_target$prototype$router4 = target.prototype.router).get.apply(_target$prototype$router4, [path].concat(middleware, [descriptor.value]));
        break;
      case HttpMethod.PUT:
        (_target$prototype$router5 = target.prototype.router).put.apply(_target$prototype$router5, [path].concat(middleware, [descriptor.value]));
        break;
      case HttpMethod.PATCH:
        (_target$prototype$router6 = target.prototype.router).patch.apply(_target$prototype$router6, [path].concat(middleware, [descriptor.value]));
        break;
      case HttpMethod.POST:
        (_target$prototype$router7 = target.prototype.router).post.apply(_target$prototype$router7, [path].concat(middleware, [descriptor.value]));
        break;
      case HttpMethod.DELETE:
        (_target$prototype$router8 = target.prototype.router)['delete'].apply(_target$prototype$router8, [path].concat(middleware, [descriptor.value]));
        break;
      default:
        throw new TypeError('@route decorator "method" is not valid');
    }
  };
}